---
title: TypedArray.prototype.forEach()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/forEach
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - Reference
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>forEach()</code></strong> method executes a provided function once per array element. This method has the same algorithm as {{jsxref("Array.prototype.forEach()")}}. <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a> here.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedarray</var>.forEach(<var>callback</var>[, <var>thisArg</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>Function that produces an element of the new typed array, taking three arguments:
 <dl>
  <dt><code><var>currentValue</var></code></dt>
  <dd>The current element being processed in the typed array.</dd>
  <dt><code><var>index</var></code></dt>
  <dd>The index of the current element being processed in the array.</dd>
  <dt><code><var>array</var></code></dt>
  <dd>The array <code>forEach()</code> was called upon.</dd>
 </dl>
 </dd>
 <dt><code><var>thisArg</var></code> {{optional_inline}}</dt>
 <dd>Value to use as <code>this</code> when executing <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>forEach()</code> method executes the provided <code><var>callback</var></code> once for each element present in the typed array in ascending order. It is not invoked for indexes that have been deleted or elided. However, it is executed for elements that are present and have the value {{jsxref("undefined")}}.</p>

<p><code><var>callback</var></code> is invoked with <strong>three arguments</strong>:</p>

<ul>
 <li>the <strong>element value</strong></li>
 <li>the <strong>element index</strong></li>
 <li>the <strong>typed array being traversed</strong></li>
</ul>

<p>If a <code><var>thisArg</var></code> parameter is provided to <code>forEach()</code>, it will be passed to <code><var>callback</var></code> when invoked, for use as its <code>this</code> value.  Otherwise, the value {{jsxref("undefined")}} will be passed for use as its <code>this</code> value. The <code>this</code> value ultimately observable by <code><var>callback</var></code> is determined according to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">the usual rules for determining the <code>this</code> seen by a function</a>.</p>

<p>The range of elements processed by <code>forEach()</code> is set before the first invocation of <code>callback</code>. Elements that are appended to the typed array after the call to <code>forEach()</code> begins will not be visited by <code><var>callback</var></code> . If the values of existing elements of the typed array are changed, the value passed to <code><var>callback</var></code> will be the value at the time <code>forEach()</code> visits them; elements that are deleted before being visited are not visited.</p>

<p><code>forEach()</code> executes the <code>callback</code> function once for each typed array element; unlike {{jsxref("TypedArray.prototype.every()", "every()")}} and {{jsxref("TypedArray.prototype.some()", "some()")}} it, always returns the value {{jsxref("undefined")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Logging_the_contents_of_a_typed_array">Logging the contents of a typed array</h3>

<p>The following code logs a line for each element in a typed array:</p>

<pre class="brush:js notranslate">function logArrayElements(element, index, array) {
  console.log('a[' + index + '] = ' + element);
}

new Uint8Array([0, 1, 2, 3]).forEach(logArrayElements);
// logs:
// a[0] = 0
// a[1] = 1
// a[2] = 2
// a[3] = 3
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.foreach', '%TypedArray%.prototype.forEach')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.TypedArray.forEach")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray.prototype.map()")}}</li>
 <li>{{jsxref("TypedArray.prototype.every()")}}</li>
 <li>{{jsxref("TypedArray.prototype.some()")}}</li>
 <li>{{jsxref("Array.prototype.forEach()")}}</li>
</ul>
